searchNodes=[{"doc":"A GenStage producer that continuously receives messages from a Redis list.This implementation follows the Reliable Queue pattern outlined in the Redis documentation.Options:redis_instance - Required. An atom representing the redis instance/connection.:list_name - Required. The name of the redis list containing items you want to process.:working_list_name - Required. The name of the redis 'working' or 'processing' list.:max_number_of_items - Optional. The maximum number of items to be fetched per pipelined request. This value generally should be between 1 and 20. Default is 10.Additional Options:redis_client - Optional. A module that implements the OffBroadway.Redis.RedisClient behaviour. This module is responsible for fetching and acknowledging the messages. Pay attention that all options passed to the producer will be forwarded to the client. It's up to the client to normalize the options it needs. Default is RedixClient.:receive_interval - Optional. The duration (in milliseconds) for which the producer waits before making a request for more items. Default is 5000.","ref":"OffBroadway.Redis.Producer.html","title":"OffBroadway.Redis.Producer","type":"module"},{"doc":"","ref":"OffBroadway.Redis.Producer.html#handle_receive_messages/1","title":"OffBroadway.Redis.Producer.handle_receive_messages/1","type":"function"},{"doc":"A generic behaviour to implement Redis Clients for OffBroadway.Redis.Producer.This module defines callbacks to normalize options and receive items from a Redis list.Modules that implement this behaviour should be passed as the :redis_client option from OffBroadway.Redis.Producer.","ref":"OffBroadway.Redis.RedisClient.html","title":"OffBroadway.Redis.RedisClient","type":"behaviour"},{"doc":"","ref":"OffBroadway.Redis.RedisClient.html#c:init/1","title":"OffBroadway.Redis.RedisClient.init/1","type":"callback"},{"doc":"","ref":"OffBroadway.Redis.RedisClient.html#c:receive_messages/2","title":"OffBroadway.Redis.RedisClient.receive_messages/2","type":"callback"},{"doc":"","ref":"OffBroadway.Redis.RedisClient.html#t:messages/0","title":"OffBroadway.Redis.RedisClient.messages/0","type":"type"},{"doc":"Default Redis client used by OffBroadway.Redis.Producer to communicate with Redis.This client implements the OffBroadway.Redis.RedisClient behaviour which defines callbacks for receiving and acknowledging items popped from a list.","ref":"OffBroadway.Redis.RedixClient.html","title":"OffBroadway.Redis.RedixClient","type":"module"},{"doc":"OffBroadway.Redis An opinionated Redis connector for Broadway to process work from a Redis list structure.Documentation can be found at https://hexdocs.pm/off_broadway_redis.This project provides:OffBroadway.Redis.Producer - A GenStage producer that continuously pops items from a Redis list and acknowledges them after being successfully processed.OffBroadway.Redis.RedisClient - A generic behaviour to implement Redis clients.OffBroadway.Redis.RedixClient - Default Redis client used by OffBroadway.Redis.Producer.","ref":"readme.html","title":"OffBroadway.Redis","type":"extras"},{"doc":"Because Redis lists do not support the concept of acknowledgements, this project utilizes the RPOPLPUSH command available in Redis to atomically pop an item from the list while moving the item to a 'working' or 'processing' list for a later pseudo-acknowledgement using the LREM command.This idea follows the blueprint of the Reliable Queue pattern outlined in the Redis documentation found here.Because RPOPLPUSH is used, the other assumption is that the head of your list will be on the right side, so you will likely want to push work into your list using LPUSH (for FIFO processing). If you want to prioritize an item to be processed next, you could push that to the right (head) by using a RPUSH.","ref":"readme.html#what-is-opinionated-about-this-library","title":"OffBroadway.Redis - What is opinionated about this library?","type":"extras"},{"doc":"The default Redis client uses the Redix library. See that project for other features.I have not attempted to use any other Redis libraries in the community at this point. I expect there may need to be changes made to this producer to accomodate others.","ref":"readme.html#redis-client","title":"OffBroadway.Redis - Redis Client","type":"extras"},{"doc":"You are responsible for maintaining your own named connection to Redis outside the scope of this library. See the Real-World Usage docs for Redix for setting up a named instance/connection.At this point, no testing has been done with a pooling strategy around Redis. I am using a single connection dedicated for my broadway pipeline in a small system. Ideally I would like to improve this to the point where just the Redis host, port, and credentials are provided to this provider for handling it's own connections/pooling.You are responsible for monitoring your working/processing list in Redis. If something goes wrong and an acknowledgement (LREM) is not handled - you will want some logic or process in place to move an item from the working list back to the main list.The Redis LREM command is O(N) - so the performance on this operation during acknowledgement will be based on the length of the list. I have been using this pattern for a number of years without problem, but be aware and do research on your own use-case to ensure this is not going to be a problem for you.","ref":"readme.html#caveats","title":"OffBroadway.Redis - Caveats","type":"extras"},{"doc":"Add :off_broadway_redis to the list of dependencies in mix.exs:def deps do [ {:off_broadway_redis, &quot;~&gt; 0.4.3&quot;} ] end","ref":"readme.html#installation","title":"OffBroadway.Redis - Installation","type":"extras"},{"doc":"Configure Broadway with one or more producers using OffBroadway.Redis.Producer:Broadway.start_link(MyBroadway, name: MyBroadway, producers: [ default: [ module: { OffBroadway.Redis.Producer, redis_instance: :some_redis_instance, list_name: &quot;some_list&quot;, working_list_name: &quot;some_list_processing&quot; } ] ] )","ref":"readme.html#usage","title":"OffBroadway.Redis - Usage","type":"extras"},{"doc":"This library was created using the Broadway Custom Producers documentation for reference. I would encourage you to view that as well as the Broadway Architecture documentation for more information.","ref":"readme.html#other-info","title":"OffBroadway.Redis - Other Info","type":"extras"},{"doc":"MIT LicenseSee the license file for details.","ref":"readme.html#license","title":"OffBroadway.Redis - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Upgrade to Broadway v0.6.0Upgrade to Redix v0.11.1","ref":"changelog.html#v0-4-2-2020-04-03","title":"Changelog - v0.4.2 (2020-04-03)","type":"extras"},{"doc":"Fix namespace(s) to adhere to Broadway community standards","ref":"changelog.html#v0-4-1-2019-09-06","title":"Changelog - v0.4.1 (2019-09-06)","type":"extras"},{"doc":"Migration from old repository for name changeUpgrade to Broadway v0.4.0Upgrade to Redix v0.10.2","ref":"changelog.html#v0-4-0-2019-09-06","title":"Changelog - v0.4.0 (2019-09-06)","type":"extras"},{"doc":"Upgrade to Broadway v0.3.0Upgrade to Redix v0.10.0","ref":"changelog.html#v0-3-0-2019-04-28","title":"Changelog - v0.3.0 (2019-04-28)","type":"extras"},{"doc":"Upgrade to Broadway v0.2.0","ref":"changelog.html#v0-2-0-2019-04-05","title":"Changelog - v0.2.0 (2019-04-05)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2019-04-03","title":"Changelog - v0.1.0 (2019-04-03)","type":"extras"},{"doc":"MIT License Copyright (c) 2019 Adam Mokan Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]